/* range.c
 *
 * Copyright 2018 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <stdio.h>

#include "array.h"

static int ret = 0;

static void
process_success (bool        success,
                 const char *func_name)
{
    if (success)
    {
        fprintf (stderr, "%s () failed\n", func_name);
        ret++;
    }
}

int
main (void)
{
    Array *array = array_new (NULL);
    bool success;

    success = array_remove_fast (array, 1);
    process_success (success, "array_remove_fast");

    success = array_remove (array, 1);
    process_success (success, "array_remove_fast");

    success = array_set (array, 1, NULL);
    process_success (success, "array_remove_fast");

    success = array_get (array, 1);
    process_success (success, "array_remove_fast");

    return ret;
}
